/*
 *  pe_code_analyzer.h
 *  ProteinEncoder
 *
 *  Created by Naoto Morikawa on 8/30/05.
 *  Copyright 2005, 2006, 2007 Naoto Morikawa. All rights reserved.
 *
 *  2006-10-01 version 0.1 release
 *  2006-11-20 version 0.2 release
 *  2007-02-15 version 0.3 release
 *  2007-04-15 version 0.4 release
 */

/* Amino acids
 * my_protein.atom[atm_ct].res_name[3]
 * my_protein.atom[s_tiles[i].error_atom].res_name[3] (if s_tiles[i].error_atom > 0)
 */
#define LONG long int		/* or long long int */
#define L_D ld			/* printf format %ld */

/* Glysin */
#define L_GLY 0			/* glycine, G */
 /* Hydrophobic */
#define L_ALA 1			/* alanine, A */
#define L_VAL 2			/* valine, V */
#define L_PHE 3			/* phenylalanine, F */
#define L_PRO 4			/* proline, P */
#define L_HYP 23	/* Hydroxyproline, - */	/* 7_Small_proteins_75/3_Knottins/6_omega/1_Cono */
#define L_MET 5			/* methionine, M */
#define L_ILE 6			/* isoleucine, I */
#define L_LEU 7			/* leucine, L */
/* Charged */
#define L_ASP 8			/* aspartic acid, D */
#define L_GLU 9			/* glutamic acid, E */
#define L_LYS 10		/* lysine, K */
#define L_ARG 11		/* arginine, R */
/* Polar */
#define L_SER 12		/* serine, S */
#define L_THR 13		/* threonine, T */
#define L_TYR 14		/* tyrosine, Y */
#define L_HIS 15		/* histidine, H */
#define L_CYS 16		/* cysteine, C */
#define L_ASN 17		/* asparagine, N */
#define L_GLN 18		/* glutamine, Q */
#define L_TRP 19		/* tryptophan, W */
/* Else */
#define L_ASX 20		/* ASP/ASN ambiguous, B */
#define L_GLX 21		/* GLU/GLN ambiguous, Z */
#define L_UNK 22		/* unknown */

struct pe_res_code {
	char name[4];		/* amino acid code */
	int type;
	LONG code;		/* 0, 1, ..., (2**segment_length) - 1 */
};

struct pe_seg_freq_tbl {
	int pos;		/* The positon of the starting residue */
	int res_freq;		/* the same residue segment */
	int code_freq;		/* the same code of the same residue segment */
};

struct pe_ud_code {
	PE_CODE *ud_seq;
	LONG inv_code;		/* pointer to the inverted code */
	int up_num;
};
